﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=10
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	Dim Sftp					As SFtp
End Sub

Sub Service_Create

End Sub

Sub Service_Start (StartingIntent As Intent)
	RevisarPDFs
End Sub

Sub Service_Destroy

End Sub

Sub RevisarPDFs
	Dim lcFileName		As String = ""
	Dim lcSFtpPuerto	As Int = 22
	Dim lcSFtpPath		As String = "/"
	'
	Log("BEGIN: RevisarPDFs")
	'
	Log("Files to Download:")
	For i = 0 To Starter.List_Files.Size -1
		Log(Starter.List_Files.Get(i))
	Next
	'
	Try
		Sftp.Initialize("SFTP", "testftpsc", "2020FTPtest#", "hairofthedog.dreamhost.com", lcSFtpPuerto)
		Sftp.SetKnownHostsStore(Starter.SysDirApk, "key.txt")
	Catch
		Log(LastException)
	End Try
	'
	Sftp.List(lcSFtpPath)
	Wait for SFTP_ListCompleted (ServerPath As String, Success As Boolean, Folders() As SFtpEntry, Files() As SFtpEntry)
	If Success = False Then
		Starter.Last_Error	= LastException.Message
		Log("Get List failed")
		Log(Starter.Last_Error)
	Else
		Log("Get List OK... Folders on server:")
		For i = 0 To Folders.Length -1
			Log(Folders(i).Name)
		Next
		Log("Files on server:")
		For i = 0 To Files.Length -1
			Log(Files(i).Name)
		Next
	End If
	'
	For i = 0 To Starter.List_Files.Size -1
		'
		lcFileName				= Starter.List_Files.Get(i)
		Starter.Current_File	= lcFileName
		'
		Log("Downloading the File:")
		Log(lcFileName)
		Log("To Folder:")
		Log(Starter.SysDirApk)
		'
		Sftp.DownloadFile(lcFileName, Starter.SysDirApk, lcFileName)
		Wait For SFTP_DownloadCompleted (ServerPath As String, Success As Boolean) '<-----
		Log($"File ${ServerPath} downloaded. Success = ${Success}"$)
		If Success = False Then
			Starter.Last_Error	= LastException.Message
			Log(Starter.Last_Error)
		End If
		'
	Next
	'
	Sftp.Close
	'
	Log("END: RevisarPDFs")

End Sub

Sub SFTP_DownloadProgress (ServerPath As String, TotalDownloaded As Long, Total As Long)
	Dim s As String
	s = "Downloaded " & Round(TotalDownloaded / 1000) & "KB"
	If Total > 0 Then s = s & " out of " & Round(Total / 1000) & "KB"
	'Log(s)
End Sub

Sub SFTP_PromptYesNo (Message As String)
	Log("Using sftp_PromptYesNo")
	'Dim res As Int = Msgbox2(Message, "", "Yes", "", "No", Null)
	'The next line might be a bit confusing. It is a condition.
	'The value will be True if res equals to DialogResponse.POSITIVE.
	Sftp.SetPromptResult(True)
End Sub